from yta_general_utils.file.filename import FileType
from typing import Union


class ErrorMessage:

    @staticmethod
    def parameter_not_provided(parameter_name: str):
        return f'The parameter "{parameter_name}" was not provided.'
    
    @staticmethod
    def parameter_is_not_string(parameter_name: str):
        return f'The parameter "{parameter_name}" provided is not a string.'
    
    @staticmethod
    def parameter_is_not_boolean(parameter_name: str):
        return f'The "{parameter_name}" parameter is not boolean.'
    
    @staticmethod
    def parameter_is_not_positive_number(parameter_name: str):
        return f'The parameter "{parameter_name}" provided is not a valid and positive number.'
    
    @staticmethod
    def parameter_is_file_that_doesnt_exist(parameter_name: str):
        return f'The "{parameter_name}" parameter provided is not a file that exists.'
    
    @staticmethod
    def parameter_is_not_file_of_file_type(parameter_name: str, value, file_type: FileType):
        return f'The "{parameter_name}" provided {value} is not a {file_type.value} filename.'
    
    @staticmethod
    def parameter_is_not_valid_url(parameter_name: str, value):
        return f'The provided "{parameter_name}" parameter {value} is not a valid url.'
    
    @staticmethod
    def parameter_is_not_class(parameter_name: str, class_names: Union[list[str], str]):
        # TODO: Check if 'class_names' is not array of str nor str
        if isinstance(class_names, str):
            class_names = [class_names]

        class_names = ', '.join(class_names)
        
        return f'The provided "{parameter_name}" parameter is not one of the next classes: {class_names}'

