from yta_general_utils.programming.enum import YTAEnum as Enum


class EditionManualTermContext(Enum):
    """
    This is the context our edition terms will have.
    The context will determine in which text topics
    we will need to apply the edition term.
    """
    
    ANY = 'any'
    """
    The term will be applied always, in any context.
    """
    
    @classmethod
    def get_default(cls):
        """
        Returns the item that acts as the one by default.
        """
        return cls.ANY